/****************************************************************************************
    Copyright 2004 uja
    Copyright 2004 Trolltech (Qt3)
    This file is part of Fleur which runs under GPL.
*****************************************************************************************/

// Hauptfenster Edelsteine

#include "window.h"

window::window(QWidget *parent,char* name): QVBox(parent,name)
{ 
  this->setMargin(16);
  this->setSpacing(4);
  this->setPaletteBackgroundColor(BACKGR0);
  this->setCaption(TITEL);  
  this->setMaximumSize(WIN_BMAX,WIN_HMAX);
  this->setMinimumSize(WIN_BMIN,WIN_HMIN);

// Zeile oben: Name, Anzeigen, Icon
  QHBox* p_zeile0=new QHBox(this);
  p_zeile0->setSpacing(8);
// Ueberschrift als Pixmap
  QLabel* p_ue =new QLabel(p_zeile0);
  p_ue->setPixmap(QPixmap(TITELBILD)); 

  // Anzeigetafel:
  QGrid* p_anzeigen=new QGrid(6,p_zeile0,"anzeigen");  // Anzeigetafel
  p_anzeigen->setPaletteBackgroundPixmap(QPixmap(BACKPIX2));
  p_anzeigen->setPaletteForegroundColor(COLOR2);
  p_anzeigen->setMinimumSize(192,32);
  p_anzeigen->setMaximumSize(360,32);
  p_anzeigen->setFrameShadow(Sunken);
  p_anzeigen->setFrameShape(Box);
  p_anzeigen->setMargin(4);

  QLabel* p_llevel =new QLabel(p_anzeigen); p_level  =new QLabel(p_anzeigen); 
  QLabel* p_lzeit  =new QLabel(p_anzeigen); p_zeit   =new QLabel(p_anzeigen); 
  QLabel* p_lpunkte=new QLabel(p_anzeigen); p_punkte =new QLabel(p_anzeigen); 
  
  p_icon=new QPushButton(p_zeile0);
  p_icon->setPixmap(QPixmap(PROGICON)); 
  p_icon->setFlat(true);
  p_icon->setFixedSize(64,64);
  p_icon->setPaletteBackgroundColor("#000000");

  p_zeile0->setStretchFactor(p_ue,1);
  p_zeile0->setStretchFactor(p_anzeigen,3);
  p_zeile0->setStretchFactor(p_icon,1);
  
// Viewport
  my_view=new viewport(this,"playfield"); // QCanvasView-Variante
  my_view->show(); 
  
// Daten einfuellen:  
  p_llevel ->setText(_LLEVEL);  
  p_lzeit  ->setText(_LTIME);  
  p_lpunkte->setText(_LSCORE);
}

void window::set_punkte(int p)    { p_punkte->setNum(p); }
void window::set_zeit(int p)      { p_zeit->setNum(p); }
void window::set_level(QString p) { p_level->setText(p); }
